﻿USE empresas;

-- EJERCICIO 1
-- QUIERO SABER EL NUMERO MAS GRANDE DE 1,12,45,67

SELECT GREATEST(1,12,45,67) mayor;

-- EJERCICIO 2
-- QUIERO SABER LA NOTA MAYOR DE LAS 3 NOTAS DE CADA PERSONA
-- LAS NOTAS SON DATO1, DATO2, DATO3

SELECT 
    p.nombre,
    p.dato1,
    p.dato2,
    p.dato3,
    GREATEST(p.dato1,p.dato2,p.dato3) 
  FROM personas p;

-- EJERCICIO 3
-- QUIERO LA NOTA MAXIMA DE TODA LA CLASE DE CADA UNO DE LOS 3 EXAMENES

SELECT 
  MAX(p.dato1),
  MAX(p.dato2),
  MAX(p.dato3) 
  FROM personas p;

-- EJERCICIO 4
-- QUIERO TODAS LAS PERSONAS CUYO NOMBRE COMIENCE POR M
-- NO PUEDO UTILIZAR LIKE

SELECT 
  * 
  FROM personas p
  WHERE
  LEFT(p.nombre,1)='m';

-- NO FUNCIONA
SELECT 
  LEFT(p.nombre,1) inicial,
  p.*
  FROM personas p
  WHERE inicial='m';

-- OTRA OPCION

SELECT 
  * 
FROM personas p
WHERE 
  SUBSTRING(p.nombre,1,1)='m';

-- EJERCICIO 5
-- QUIERO DEMOSTRAR LA UTILIZADA DE IN PARA SUBCONSULTAS
-- QUIERO LAS PERSONAS QUE VIVEN EN UNA POBLACION DONDE HAYA ALGUNA EMPRESA


SELECT 
    * 
  FROM personas p
  WHERE 
  p.poblacion IN (
    SELECT DISTINCT e.poblacion FROM empresas e -- POBLACIONES DE LAS EMPRESAS
  );